#include "bttngrppage.h"

ButtonGroupPage::ButtonGroupPage(QWidget *parent, const char *name)
: PropPage(parent, name)
{
  QFont fnt;
  QColor fg, bg, light, dark, mid, text, base;
  QColorGroup normal, disabled, active;
  QPalette pal;

  this->resize(400, 300);
  optGrp = new QGroupBox(this);
  optGrp->setGeometry(0, 0, 310, 55);
  optGrp->setTitle("Options");
  exclBox = new QCheckBox(optGrp);
  exclBox->setGeometry(5, 20, 100, 25);
  exclBox->setText("Exclusive");

  connect(exclBox, SIGNAL(clicked()), SLOT(setDirty()) );
}

ButtonGroupPage::~ButtonGroupPage()
{
}

void ButtonGroupPage::setTarget(QWidget *target)
{
  _target = (QButtonGroup *)target;
  exclBox->setChecked(_target->isExclusive());
  dirty = 0;
}

void ButtonGroupPage::applyValues()
{
  if(! dirty)
    return;
  _target->setExclusive(exclBox->isChecked());
}
