#include "bttnpage.h"

ButtonPage::ButtonPage(QWidget *parent, const char *name)
: PropPage(parent, name)
{
  QFont fnt;
  QColor fg, bg, light, dark, mid, text, base;
  QColorGroup normal, disabled, active;
  QPalette pal;

  this->resize(400, 300);
  labGrp = new QGroupBox(this);
  labGrp->setGeometry(0, 0, 310, 55);
  labGrp->setTitle("Label");
  labelEdit = new QLineEdit(labGrp);
  labelEdit->setGeometry(5, 20, 300, 25);
  optGrp = new QGroupBox(this);
  optGrp->setGeometry(0, 55, 310, 55);
  optGrp->setTitle("Options");
  aresBox = new QCheckBox(optGrp);
  aresBox->setGeometry(5, 20, 100, 25);
  aresBox->setText("Auto Resize");
  arepBox = new QCheckBox(optGrp);
  arepBox->setGeometry(150, 20, 100, 25);
  arepBox->setText("Auto Repeat");

  connect(labelEdit, SIGNAL(textChanged(const char *)), SLOT(setDirty(const char *)) );
  connect(aresBox, SIGNAL(clicked()), SLOT(setDirty()) );
  connect(arepBox, SIGNAL(clicked()), SLOT(setDirty()) );
}

ButtonPage::~ButtonPage()
{
}

void ButtonPage::setTarget(QWidget *target)
{
  _target = (QButton *)target;
  QString tmpStr(_target->text());
  tmpStr.replace(QRegExp("\n"), "\\n");
  labelEdit->setText(tmpStr);
  aresBox->setChecked(_target->autoResize());
  arepBox->setChecked(_target->autoRepeat());
  dirty = 0;
}

void ButtonPage::applyValues()
{
  if(! dirty)
    return;
  QString tmpStr(labelEdit->text());
  int idx = tmpStr.find("\\n");
  while(idx != -1)
  {
    tmpStr = tmpStr.left(idx) + '\n'
             + tmpStr.right(tmpStr.length()-idx-2);
    idx = tmpStr.find("\\n", idx);
  }
  _target->setText(tmpStr);
  _target->setAutoResize(aresBox->isChecked());
  _target->setAutoRepeat(arepBox->isChecked());
}
