#include "colmixer.h"

ColorMixer::ColorMixer(QWidget *parent, const char *name)
: QDialog(parent, name, TRUE)
{
  QFont fnt;
  QColor fg, bg, light, dark, mid, text, base;
  QColorGroup normal, disabled, active;
  QPalette pal;

  this->resize(360, 205);
  stdColGrp = new QButtonGroup(this);
  stdColGrp->setGeometry(10, 10, 340, 20);
  stdColGrp->setFrameStyle(0);
  but0 = new QPushButton(stdColGrp);
  but0->setGeometry(0, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(0, 0, 0);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but0->setPalette(pal);
  but1 = new QPushButton(stdColGrp);
  but1->setGeometry(20, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(255, 255, 255);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but1->setPalette(pal);
  but2 = new QPushButton(stdColGrp);
  but2->setGeometry(40, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(128, 128, 128);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but2->setPalette(pal);
  but3 = new QPushButton(stdColGrp);
  but3->setGeometry(60, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(160, 160, 164);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but3->setPalette(pal);
  but4 = new QPushButton(stdColGrp);
  but4->setGeometry(80, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but4->setPalette(pal);
  but5 = new QPushButton(stdColGrp);
  but5->setGeometry(100, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(255, 0, 0);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but5->setPalette(pal);
  but6 = new QPushButton(stdColGrp);
  but6->setGeometry(120, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(0, 255, 0);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but6->setPalette(pal);
  but7 = new QPushButton(stdColGrp);
  but7->setGeometry(140, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(0, 0, 255);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but7->setPalette(pal);
  but8 = new QPushButton(stdColGrp);
  but8->setGeometry(160, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(0, 255, 255);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but8->setPalette(pal);
  but9 = new QPushButton(stdColGrp);
  but9->setGeometry(180, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(255, 0, 255);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but9->setPalette(pal);
  but10 = new QPushButton(stdColGrp);
  but10->setGeometry(200, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(255, 255, 0);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but10->setPalette(pal);
  but11 = new QPushButton(stdColGrp);
  but11->setGeometry(220, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(128, 0, 0);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but11->setPalette(pal);
  but12 = new QPushButton(stdColGrp);
  but12->setGeometry(240, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(0, 128, 0);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but12->setPalette(pal);
  but13 = new QPushButton(stdColGrp);
  but13->setGeometry(260, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(0, 0, 128);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but13->setPalette(pal);
  but14 = new QPushButton(stdColGrp);
  but14->setGeometry(280, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(0, 128, 128);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but14->setPalette(pal);
  but15 = new QPushButton(stdColGrp);
  but15->setGeometry(300, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(128, 0, 128);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but15->setPalette(pal);
  but16 = new QPushButton(stdColGrp);
  but16->setGeometry(320, 0, 20, 20);
  fg.setRgb(0, 0, 0);
  bg.setRgb(128, 128, 0);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  normal = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(128, 128, 128);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(128, 128, 128);
  base.setRgb(192, 192, 192);
  disabled = QColorGroup(fg, bg, light, dark, mid, text, base);
  fg.setRgb(0, 0, 0);
  bg.setRgb(192, 192, 192);
  light.setRgb(255, 255, 255);
  dark.setRgb(96, 96, 96);
  mid.setRgb(160, 160, 164);
  text.setRgb(0, 0, 0);
  base.setRgb(255, 255, 255);
  active = QColorGroup(fg, bg, light, dark, mid, text, base);
  pal = QPalette(normal, disabled, active);
  but16->setPalette(pal);
  colFrame = new QFrame(this);
  colFrame->setGeometry(290, 45, 60, 100);
  colFrame->setFrameStyle(50);
  untitled_0 = new QLabel(this);
  untitled_0->setGeometry(10, 40, 20, 30);
  untitled_0->setText("R");
  redSlide = new QSlider(this);
  redSlide->setGeometry(40, 45, 200, 20);
  redSlide->setValue(0);
  redSlide->setRange(0, 255);
  redSlide->setOrientation((QSlider::Orientation)0);
  redVal = new QLabel(this);
  redVal->setGeometry(250, 40, 40, 30);
  untitled_1 = new QLabel(this);
  untitled_1->setGeometry(10, 80, 20, 30);
  untitled_1->setText("G");
  greenSlide = new QSlider(this);
  greenSlide->setGeometry(40, 85, 200, 20);
  greenSlide->setValue(0);
  greenSlide->setRange(0, 255);
  greenSlide->setOrientation((QSlider::Orientation)0);
  greenVal = new QLabel(this);
  greenVal->setGeometry(250, 80, 40, 30);
  untitled_2 = new QLabel(this);
  untitled_2->setGeometry(10, 120, 20, 30);
  untitled_2->setText("B");
  blueSlide = new QSlider(this);
  blueSlide->setGeometry(40, 125, 200, 20);
  blueSlide->setValue(0);
  blueSlide->setRange(0, 255);
  blueSlide->setOrientation((QSlider::Orientation)0);
  blueVal = new QLabel(this);
  blueVal->setGeometry(250, 120, 40, 30);
  cancelBut = new QPushButton(this);
  cancelBut->setGeometry(250, 170, 80, 25);
  cancelBut->setText("&Cancel");
  okBut = new QPushButton(this);
  okBut->setGeometry(165, 170, 80, 25);
  okBut->setText("&Ok");
  okBut->setDefault((bool)1);

  connect(stdColGrp, SIGNAL(clicked(int)), SLOT(setstdcolor(int)) );
  connect(redSlide, SIGNAL(valueChanged(int)), SLOT(setrgbcolor(int)) );
  connect(greenSlide, SIGNAL(valueChanged(int)), SLOT(setrgbcolor(int)) );
  connect(blueSlide, SIGNAL(valueChanged(int)), SLOT(setrgbcolor(int)) );
  connect(okBut, SIGNAL(clicked()), SLOT(accept()) );
  connect(cancelBut, SIGNAL(clicked()), SLOT(reject()) );
}

ColorMixer::~ColorMixer()
{
}

const QColor & ColorMixer::color()
{
  return colFrame->backgroundColor();
}

void ColorMixer::setColor(const QColor &col)
{
  colFrame->setBackgroundColor(col);
  redSlide->setValue(col.red());
  greenSlide->setValue(col.green());
  blueSlide->setValue(col.blue());
  redVal->setNum(col.red());
  greenVal->setNum(col.green());
  blueVal->setNum(col.blue());
}

void ColorMixer::setstdcolor(int val)
{
  QPushButton *but;
  switch(val)
  {
    case 0: but = but0; break;
    case 1: but = but1; break;
    case 2: but = but2; break;
    case 3: but = but3; break;
    case 4: but = but4; break;
    case 5: but = but5; break;
    case 6: but = but6; break;
    case 7: but = but7; break;
    case 8: but = but8; break;
    case 9: but = but9; break;
    case 10: but = but10; break;
    case 11: but = but11; break;
    case 12: but = but12; break;
    case 13: but = but13; break;
    case 14: but = but14; break;
    case 15: but = but15; break;
    case 16: but = but16; break;
  }
  QColor tmp = but->backgroundColor();
  colFrame->setBackgroundColor(but->backgroundColor());
  redSlide->setValue(tmp.red());
  greenSlide->setValue(tmp.green());
  blueSlide->setValue(tmp.blue());
  redVal->setNum(tmp.red());
  greenVal->setNum(tmp.green());
  blueVal->setNum(tmp.blue());
}

void ColorMixer::setrgbcolor(int dummy)
{
  QColor tmp(redSlide->value(), greenSlide->value(), blueSlide->value());
  colFrame->setBackgroundColor(tmp);
  QString buffer;
  buffer.setNum(redSlide->value());
  redVal->setText(buffer);
  buffer.setNum(greenSlide->value());
  greenVal->setText(buffer);
  buffer.setNum(blueSlide->value());
  blueVal->setText(buffer);
}
