%{
#include <iostream.h>
#include <qstring.h>

QString type;

%}

BASETYPE QWidget|QDialog|QMDialog
NAME \[[^\]]*\]

%x GetName
%x WaitForBracket
%x CopyTillEnd

%%
%{
%}

{BASETYPE} {
  type = yytext;
  if(type == "QWidget")
    cout << "QWidget";
  else if(type == "QDialog")
    cout << "QDialog";
  else //(type == "QMDialog")
    cout << "QDialog";
  BEGIN(GetName);
}

<GetName>{NAME} {
  cout << yytext;
  BEGIN(WaitForBracket);
}

<WaitForBracket>\{ {
  cout << "{\n";
  if(type == "QWidget")
  {
    cout << "Arguments {QWidget *parent, const char *name}\n";
    cout << "BaseClass {QWidget}\n";
    cout << "BaseInit {: QWidget(parent, name)}\n";
    cout << "BaseHeader {qwidget.h}\n";
    cout << "Modal {0}\n";
  }
  else if(type == "QDialog")
  {
    cout << "Arguments {QWidget *parent, const char *name}\n";
    cout << "BaseClass {QDialog}\n";
    cout << "BaseInit {: QDialog(parent, name, FALSE)}\n";
    cout << "BaseHeader {qdialog.h}\n";
    cout << "Modal {0}\n";
  }
  else //(type == "QMDialog")
  {
    cout << "Arguments {QWidget *parent, const char *name}\n";
    cout << "BaseClass {QWidget}\n";
    cout << "BaseInit {: QDialog(parent, name, TRUE)}\n";
    cout << "BaseHeader {qdialog.h}\n";
    cout << "Modal {1}\n";
  }
  BEGIN(CopyTillEnd);
}

%%

int main(int argc, char **argv)
{
  if(argc < 2)
  {
    cerr << "Converts .wdg files from 0.30 to 0.40 version\n";
    cerr << "*** Usage: convert <infile> > <outfile>\n";
    return 1;
  }
  FILE *fp = fopen(argv[1], "r");
  if(! fp)
  {
    cerr << "*** Unable to open file\n";
    return 1;
  }
  yyin = fp;
  yylex();

  return 0;
}
