#ifndef FontPage_included
#define FontPage_included

#include <proppage.h>
#include <qchkbox.h>
#include <qradiobt.h>
#include <qcombo.h>
#include <qgrpbox.h>
#include <qbttngrp.h>
#include <qlined.h>

#include <stdlib.h>
#include <qstring.h>

class FontPage: public PropPage
{
  Q_OBJECT
  public:
    FontPage(QWidget *parent, const char *name);
    ~FontPage();
    void setTarget(QWidget *target);
  public slots:
    void applyValues();
  private slots:
    void toggleFont(int but);
    void toggleSize(int but);
    void toggleWeight(int but);
  private:
    QWidget * _target;
  private:
    QButtonGroup *famGrp;
    QRadioButton *fstdBut;
    QRadioButton *fudefBut;
    QComboBox *fontCombo;
    QLineEdit *fontEdit;
    QGroupBox *styleGrp;
    QCheckBox *itBox;
    QCheckBox *strBox;
    QCheckBox *ulBox;
    QCheckBox *fixBox;
    QButtonGroup *weightGrp;
    QComboBox *weightCombo;
    QRadioButton *wstdBut;
    QRadioButton *wudefBut;
    QLineEdit *weightEdit;
    QButtonGroup *sizeGrp;
    QRadioButton *sstdBut;
    QRadioButton *sudefBut;
    QComboBox *sizeCombo;
    QLineEdit *sizeEdit;
};

#endif
