#include "grpboxpage.h"

GroupBoxPage::GroupBoxPage(QWidget *parent, const char *name)
: PropPage(parent, name)
{
  QFont fnt;
  QColor fg, bg, light, dark, mid, text, base;
  QColorGroup normal, disabled, active;
  QPalette pal;

  this->resize(400, 300);
  titleGrp = new QGroupBox(this);
  titleGrp->setGeometry(0, 0, 310, 55);
  titleGrp->setTitle("Title");
  titleEdit = new QLineEdit(titleGrp);
  titleEdit->setGeometry(5, 20, 180, 25);
  alignCombo = new QComboBox(titleGrp);
  alignCombo->setGeometry(200, 20, 100, 25);
  alignCombo->insertItem("AlignLeft");
  alignCombo->insertItem("AlignRight");
  alignCombo->insertItem("AlignCenter");

  connect(titleEdit, SIGNAL(textChanged(const char *))
          , SLOT(setDirty(const char *)) );
  connect(alignCombo, SIGNAL(activated(int)), SLOT(setDirty(int)) );
}

GroupBoxPage::~GroupBoxPage()
{
}

void GroupBoxPage::setTarget(QWidget *target)
{
  _target = (QGroupBox *)target;
  QString tmpStr(_target->title());
  tmpStr.replace(QRegExp("\n"), "\\n");
  titleEdit->setText(tmpStr);
  switch(_target->alignment())
  {
    case AlignLeft:
      alignCombo->setCurrentItem(0);
      break;
    case AlignRight:
      alignCombo->setCurrentItem(1);
      break;
    default:
      alignCombo->setCurrentItem(2);
  }
  dirty = 0;
}

void GroupBoxPage::applyValues()
{
  if(! dirty)
    return;
  QString tmpStr(titleEdit->text());
  int idx = tmpStr.find("\\n");
  while(idx != -1)
  {
    tmpStr = tmpStr.left(idx) + '\n'
             + tmpStr.right(tmpStr.length()-idx-2);
    idx = tmpStr.find("\\n", idx);
  }
  _target->setTitle(tmpStr);
  switch(alignCombo->currentItem())
  {
    case 0:
      _target->setAlignment(AlignLeft);
      break;
    case 1:
      _target->setAlignment(AlignRight);
      break;
    default:
      _target->setAlignment(AlignHCenter);
      break;
  }
}
