#include "incmdl.h"

InclListModule::InclListModule(QWidget *parent, const char *name)
: QWidget(parent, name)
{
  QFont fnt;
  QColor fg, bg, light, dark, mid, text, base;
  QColorGroup normal, disabled, active;
  QPalette pal;

  this->resize(270, 155);
  this->setCaption("Include Files");
  backFrame = new QFrame(this);
  backFrame->setGeometry(5, 10, 260, 135);
  backFrame->setFrameStyle(49);
  inclList = new QListBox(backFrame);
  inclList->setGeometry(10, 10, 150, 110);
  addBut = new QPushButton(backFrame);
  addBut->setGeometry(170, 10, 80, 25);
  addBut->setText("Add");
  delBut = new QPushButton(backFrame);
  delBut->setGeometry(170, 50, 80, 25);
  delBut->setText("Delete");
  editBut = new QPushButton(backFrame);
  editBut->setGeometry(170, 90, 80, 25);
  editBut->setText("Edit");

  GeoMgr *manager = new GeoMgr(this);
  manager->init();
  manager->setLayoutInfo(backFrame, NW_GRAV, SE_GRAV, RESIZE_ALL);
  GeoMgr *submgr = new GeoMgr(backFrame);
  submgr->init();
  submgr->setLayoutInfo(inclList, NW_GRAV, SE_GRAV, RESIZE_ALL);
  submgr->setLayoutInfo(addBut, E_GRAV, E_GRAV, RESIZE_NONE);
  submgr->setLayoutInfo(delBut, E_GRAV, E_GRAV, RESIZE_NONE);
  submgr->setLayoutInfo(editBut, E_GRAV, E_GRAV, RESIZE_NONE);
  connect(addBut, SIGNAL(clicked()), SLOT(addInclude()) );
  connect(delBut, SIGNAL(clicked()), SLOT(delInclude()) );
  connect(editBut, SIGNAL(clicked()), SLOT(editInclude()) );
}

InclListModule::~InclListModule()
{
}

void InclListModule::setList(QList<IncludeFile> &lst)
{
  list = &lst;
  update();
}

void InclListModule::addInclude()
{
  ValModal tmp(0, "");
  tmp.setQuestion("New include:");
  tmp.setText("");
  tmp.showAtCursor();
  if(tmp.result())
  {
    IncludeFile *entry = new IncludeFile;
    entry->name = tmp.text();
    list->append(entry);
    update();
  }
}

void InclListModule::delInclude()
{
  int idx = inclList->currentItem();
  if(idx < 0)
    return;
  list->remove(idx);
  update();
}

void InclListModule::editInclude()
{
  int idx = inclList->currentItem();
  if(idx < 0)
    return;
  editInclude(idx);
}

void InclListModule::editInclude(int idx)
{
  QListIterator<IncludeFile> it(*list);
  for(int i=0; i<idx; i++)
    ++it;
  IncludeFile *curr = it.current();
  ValModal tmp(0, "");
  tmp.setQuestion("Include File:");
  tmp.setText(curr->name);
  tmp.showAtCursor();
  if(tmp.result())
  {
    curr->name = tmp.text();
    update();
  }
}

void InclListModule::update()
{
  inclList->clear();
  QListIterator<IncludeFile> it(*list);
  for(; it.current(); ++it)
    inclList->insertItem(it.current()->name);
}

void InclListModule::closeEvent(QCloseEvent *ev)
{
  ev->ignore();
  QMessageBox::warning(this, "Ebuilder",
              "Use the window menu item to close this window");
}
