#include <qapp.h>
#include <qwidget.h>
#include <qpushbt.h>
#include <qmsgbox.h>

#include "dsgnmdl.h"
#include "storemdl.h"
#include "prefmdl.h"

//
// Application globals
//
StorageModule *store;
PrefModule *prefs;
DesignModule *designer;

int main(int argc, char **argv)
{
  QApplication *app = new QApplication(argc, argv);
  app->setStyle(WindowsStyle);
  designer = new DesignModule(0);
  app->connect(designer, SIGNAL(quit()), SLOT(quit()) );
  app->setMainWidget(designer);

  // Create the storage module
  store = new StorageModule(0);

  // Create the preference module
  prefs = new PrefModule(0, "");
  prefs->hide();
  prefs->init();

# if(QT_VERSION < 132)
  QMessageBox::warning(designer, "Ebuilder"
                       , "Your are using a QT version prior to\n"
                       "1.32. This application will not run\n"
                       "correctly with this version.\n"
                       "Please upgrade your library");
#endif

  designer->show();
  return app->exec();
}
