#include <qregexp.h>
#include "mfmodal.h"

MemberFuncModal::MemberFuncModal(QWidget *parent, const char *name)
: QDialog(parent, name, TRUE)
{
  QFont fnt;
  QColor fg, bg, light, dark, mid, text, base;
  QColorGroup normal, disabled, active;
  QPalette pal;

  this->resize(505, 415);
  this->setCaption("Member Function");
  backFrame = new QFrame(this);
  backFrame->setGeometry(5, 5, 495, 365);
  backFrame->setFrameStyle(49);
  untitled_0 = new QLabel(backFrame);
  untitled_0->setGeometry(10, 15, 90, 25);
  untitled_0->setText("Return Type");
  untitled_0->setAlignment(33);
  typeEdit = new QLineEdit(backFrame);
  typeEdit->setGeometry(100, 15, 185, 25);
  untitled_1 = new QLabel(backFrame);
  untitled_1->setGeometry(10, 55, 90, 25);
  untitled_1->setText("Function Name");
  untitled_1->setAlignment(33);
  nameEdit = new QLineEdit(backFrame);
  nameEdit->setGeometry(100, 55, 185, 25);
  untitled_2 = new QLabel(backFrame);
  untitled_2->setGeometry(10, 95, 90, 25);
  untitled_2->setText("Argument List");
  untitled_2->setAlignment(33);
  argEdit = new QLineEdit(backFrame);
  argEdit->setGeometry(100, 95, 385, 25);
  mtypeGrp = new QButtonGroup(backFrame);
  mtypeGrp->setGeometry(295, 10, 90, 75);
  mtypeGrp->setExclusive((bool)1);
  normBox = new QRadioButton(mtypeGrp);
  normBox->setGeometry(5, 5, 80, 25);
  normBox->setText("Normal");
  normBox->setChecked((bool)1);
  sigBox = new QRadioButton(mtypeGrp);
  sigBox->setGeometry(5, 25, 80, 25);
  sigBox->setText("SIGNAL");
  slotBox = new QRadioButton(mtypeGrp);
  slotBox->setGeometry(5, 45, 80, 25);
  slotBox->setText("SLOT");
  atypeGrp = new QButtonGroup(backFrame);
  atypeGrp->setGeometry(395, 10, 90, 75);
  atypeGrp->setExclusive((bool)1);
  pubBox = new QRadioButton(atypeGrp);
  pubBox->setGeometry(5, 5, 80, 25);
  pubBox->setText("Public");
  pubBox->setChecked((bool)1);
  protBox = new QRadioButton(atypeGrp);
  protBox->setGeometry(5, 25, 80, 25);
  protBox->setText("Protected");
  privBox = new QRadioButton(atypeGrp);
  privBox->setGeometry(5, 45, 80, 25);
  privBox->setText("Private");
  textEdit = new QMultiLineEdit(backFrame);
  textEdit->setGeometry(10, 130, 475, 200);
  textEdit->insertLine("");
  aiBox = new QCheckBox(backFrame);
  aiBox->setGeometry(20, 335, 120, 25);
  aiBox->setText("Auto Indent");
  aiBox->setChecked((bool)1);
  doneBut = new QPushButton(this);
  doneBut->setGeometry(270, 380, 100, 25);
  doneBut->setText("Done");
  doneBut->setDefault((bool)1);
  cancelBut = new QPushButton(this);
  cancelBut->setGeometry(385, 380, 100, 25);
  cancelBut->setText("Cancel");

  GeoMgr *manager = new GeoMgr(this);
  manager->init();
  manager->setLayoutInfo(doneBut, SE_GRAV, SE_GRAV, RESIZE_NONE);
  manager->setLayoutInfo(cancelBut, SE_GRAV, SE_GRAV, RESIZE_NONE);
  GeoMgr *submgr1 = new GeoMgr(backFrame);
  submgr1->init();
  submgr1->setLayoutInfo(untitled_0, NW_GRAV, NW_GRAV, RESIZE_NONE);
  submgr1->setLayoutInfo(untitled_1, NW_GRAV, NW_GRAV, RESIZE_NONE);
  submgr1->setLayoutInfo(untitled_2, NW_GRAV, NW_GRAV, RESIZE_NONE);
  submgr1->setLayoutInfo(typeEdit, NW_GRAV, NE_GRAV, RESIZE_X);
  submgr1->setLayoutInfo(nameEdit, NW_GRAV, NE_GRAV, RESIZE_X);
  submgr1->setLayoutInfo(argEdit, NW_GRAV, NE_GRAV, RESIZE_X);
  submgr1->setLayoutInfo(textEdit, NW_GRAV, SE_GRAV, RESIZE_ALL);
  submgr1->setLayoutInfo(aiBox, SW_GRAV, SW_GRAV, RESIZE_NONE);
  submgr1->setLayoutInfo(mtypeGrp, NE_GRAV, NE_GRAV, RESIZE_NONE);
  GeoMgr *submgr2 = new GeoMgr(mtypeGrp);
  submgr2->init();
  submgr2->setLayoutInfo(normBox, NW_GRAV, NW_GRAV, RESIZE_NONE);
  submgr2->setLayoutInfo(sigBox, NW_GRAV, NW_GRAV, RESIZE_NONE);
  submgr2->setLayoutInfo(slotBox, NW_GRAV, NW_GRAV, RESIZE_NONE);
  submgr1->setLayoutInfo(atypeGrp, NE_GRAV, NE_GRAV, RESIZE_NONE);
  GeoMgr *submgr3 = new GeoMgr(atypeGrp);
  submgr3->init();
  submgr3->setLayoutInfo(pubBox, NW_GRAV, NW_GRAV, RESIZE_NONE);
  submgr3->setLayoutInfo(protBox, NW_GRAV, NW_GRAV, RESIZE_NONE);
  submgr3->setLayoutInfo(privBox, NW_GRAV, NW_GRAV, RESIZE_NONE);
  connect(mtypeGrp, SIGNAL(clicked(int)), SLOT(newmtype(int)) );
  connect(doneBut, SIGNAL(clicked()), SLOT(applyValues()) );
  connect(cancelBut, SIGNAL(clicked()), SLOT(reject()) );
  connect(textEdit, SIGNAL(returnPressed()), SLOT(doAutoIndent()) );
}

MemberFuncModal::~MemberFuncModal()
{
}

void MemberFuncModal::setMember(MemberFunction *mf)
{
  target = mf;
  typeEdit->setText(mf->type);
  nameEdit->setText(mf->name);
  argEdit->setText(mf->arglist);
  pubBox->setChecked(0);
  protBox->setChecked(0);
  privBox->setChecked(0);
  sigBox->setChecked(0);
  slotBox->setChecked(0);
  normBox->setChecked(0);
  if(mf->extra == "signal")
  {
    sigBox->setChecked(1);
    pubBox->setEnabled(0);
    protBox->setEnabled(0);
    privBox->setEnabled(0);
    typeEdit->setText("void");
    typeEdit->setEnabled(0);
    textEdit->setEnabled(0);
  }
  else if(mf->extra == "slot")
  {
    slotBox->setChecked(1);
    pubBox->setEnabled(1);
    protBox->setEnabled(1);
    privBox->setEnabled(1);
    typeEdit->setText("void");
    typeEdit->setEnabled(0);
    textEdit->setEnabled(1);
  }
  else if(mf->extra == "normal")
  {
    normBox->setChecked(1);
    pubBox->setEnabled(1);
    protBox->setEnabled(1);
    privBox->setEnabled(1);
    typeEdit->setEnabled(1);
    textEdit->setEnabled(1);
  }
  else if(mf->extra == "ctor" || mf->extra == "dtor")
  {
    normBox->setChecked(1);
    pubBox->setEnabled(0);
    protBox->setEnabled(0);
    privBox->setEnabled(0);
    sigBox->setEnabled(0);
    slotBox->setEnabled(0);
    normBox->setEnabled(0);
    typeEdit->setEnabled(0);
    nameEdit->setEnabled(0);
    argEdit->setEnabled(0);
    textEdit->setEnabled(1);
  }
  else //(mf->extra == "")
  {
    normBox->setChecked(1);
  }
  if(mf->access == "public")
    pubBox->setChecked(1);
  else if(mf->access == "protected")
    protBox->setChecked(1);
  else //(mf->access == "private")
    privBox->setChecked(1);
  textEdit->setText(mf->text);
}

void MemberFuncModal::applyValues()
{
  if(target->extra == "ctor" || target->extra == "dtor")
  {
    target->text = textEdit->text();
    if(target->text[target->text.length()-1] != '\n')
      target->text = target->text + '\n';
    accept();
    return;
  }
  
  // Check the validity of the fields
  if(*typeEdit->text() == '\0')
  {
    QMessageBox::critical(this, "Ebuilder", "You must enter a type");
    return;
  }
  if(*nameEdit->text() == '\0')
  {
    QMessageBox::critical(this, "Ebuilder", "You must enter a name");
    return;
  }
  target->type = typeEdit->text();
  target->name = nameEdit->text();
  target->arglist = argEdit->text();
  if(pubBox->isChecked())
    target->access = "public";
  else if(protBox->isChecked())
    target->access = "protected";
  else //(privBox->isChecked())
    target->access = "private";
  if(sigBox->isChecked())
    target->extra = "signal";
  else if(slotBox->isChecked())
    target->extra = "slot";
  else //(normBox->isChecked())
    target->extra = "";

  // Remove empty lines or lines with only whitespace at the end of the text
  target->text = textEdit->text();
  int idx = target->text.findRev(QRegExp("[^\t\n ]"));
  target->text = target->text.left(idx+1) + "\n";

  accept();
}

void MemberFuncModal::newmtype(int idx)
{
  if(idx == 0) //Normal
  {
    pubBox->setEnabled(1);
    protBox->setEnabled(1);
    privBox->setEnabled(1);
    typeEdit->setEnabled(1);
    textEdit->setEnabled(1);
  }
  else if(idx == 1) //SIGNAL
  {
    pubBox->setChecked(1);
    protBox->setChecked(0);
    privBox->setChecked(0);
    pubBox->setEnabled(0);
    protBox->setEnabled(0);
    privBox->setEnabled(0);
    typeEdit->setText("void");
    typeEdit->setEnabled(0);
    textEdit->setEnabled(0);
  }
  else //(idx == 2) //SLOT
  {
    pubBox->setChecked(1);
    protBox->setChecked(0);
    privBox->setChecked(0);
    pubBox->setEnabled(1);
    protBox->setEnabled(1);
    privBox->setEnabled(1);
    typeEdit->setText("void");
    typeEdit->setEnabled(0);
    textEdit->setEnabled(1);
  }
}

void MemberFuncModal::doAutoIndent()
{
  if(! aiBox->isChecked())
    return;
  int line, col;
  textEdit->getCursorPosition(&line, &col);
  if(line)
  {
    const char *prevLine = textEdit->textLine(line-1);
    int i = 0;
    while(prevLine[i] == ' ')
      i++;
    while(i--)
      textEdit->insertAt(" ", line, col);
  }
}
