#include "mlinedpage.h"

MultiLineEditPage::MultiLineEditPage(QWidget *parent, const char *name)
: PropPage(parent, name)
{
  QFont fnt;
  QColor fg, bg, light, dark, mid, text, base;
  QColorGroup normal, disabled, active;
  QPalette pal;

  this->resize(400, 300);
  textGrp = new QGroupBox(this);
  textGrp->setGeometry(0, 0, 310, 140);
  textGrp->setTitle("Text");
  mlineEdit = new QMultiLineEdit(textGrp);
  mlineEdit->setGeometry(5, 20, 300, 115);
  mlineEdit->insertLine("");
  optGrp = new QGroupBox(this);
  optGrp->setGeometry(0, 140, 310, 55);
  optGrp->setTitle("Options");
  readBox = new QCheckBox(optGrp);
  readBox->setGeometry(5, 20, 130, 25);
  readBox->setText("Read Only");
  overwriteBox = new QCheckBox(optGrp);
  overwriteBox->setGeometry(140, 20, 130, 25);
  overwriteBox->setText("Overwrite Mode");

  connect(mlineEdit, SIGNAL(textChanged()), SLOT(setDirty()) );
  connect(readBox, SIGNAL(clicked()), SLOT(setDirty()) );
  connect(overwriteBox, SIGNAL(clicked()), SLOT(setDirty()) );
}

MultiLineEditPage::~MultiLineEditPage()
{
}

void MultiLineEditPage::setTarget(QWidget *target)
{
  _target = (QMultiLineEdit *)target;
  mlineEdit->clear();
  for(int i=0; i<_target->numLines(); i++)
    mlineEdit->insertLine(_target->textLine(i));
  readBox->setChecked(_target->isReadOnly());
  overwriteBox->setChecked(_target->isOverwriteMode());
  dirty = 0;
}

void MultiLineEditPage::applyValues()
{
  if(! dirty)
    return;
  _target->clear();
  for(int i=0; i<mlineEdit->numLines(); i++)
    _target->insertLine(mlineEdit->textLine(i));
  _target->setReadOnly(readBox->isChecked());
  _target->setOverwriteMode(overwriteBox->isChecked());
}
