#include "mvmodal.h"

MemberVarModal::MemberVarModal(QWidget *parent, const char *name)
: QDialog(parent, name, TRUE)
{
  QFont fnt;
  QColor fg, bg, light, dark, mid, text, base;
  QColorGroup normal, disabled, active;
  QPalette pal;

  this->resize(375, 145);
  this->setCaption("Member Variable");
  backFrame = new QFrame(this);
  backFrame->setGeometry(5, 5, 365, 95);
  backFrame->setFrameStyle(49);
  untitled_0 = new QLabel(backFrame);
  untitled_0->setGeometry(10, 15, 60, 25);
  untitled_0->setText("Type");
  untitled_0->setAlignment(33);
  typeEdit = new QLineEdit(backFrame);
  typeEdit->setGeometry(70, 15, 185, 25);
  untitled_1 = new QLabel(backFrame);
  untitled_1->setGeometry(10, 55, 60, 25);
  untitled_1->setText("Name");
  untitled_1->setAlignment(33);
  nameEdit = new QLineEdit(backFrame);
  nameEdit->setGeometry(70, 55, 185, 25);
  atypeGrp = new QButtonGroup(backFrame);
  atypeGrp->setGeometry(265, 10, 90, 75);
  atypeGrp->setExclusive((bool)1);
  pubBox = new QRadioButton(atypeGrp);
  pubBox->setGeometry(5, 5, 80, 25);
  pubBox->setText("Public");
  pubBox->setChecked((bool)1);
  protBox = new QRadioButton(atypeGrp);
  protBox->setGeometry(5, 25, 80, 25);
  protBox->setText("Protected");
  privBox = new QRadioButton(atypeGrp);
  privBox->setGeometry(5, 45, 80, 25);
  privBox->setText("Private");
  doneBut = new QPushButton(this);
  doneBut->setGeometry(260, 110, 100, 25);
  doneBut->setText("Done");
  cancelBut = new QPushButton(this);
  cancelBut->setGeometry(150, 110, 100, 25);
  cancelBut->setText("Cancel");

  GeoMgr *manager = new GeoMgr(this);
  manager->init();
  manager->setLayoutInfo(backFrame, NW_GRAV, SE_GRAV, RESIZE_ALL);
  manager->setLayoutInfo(doneBut, SE_GRAV, SE_GRAV, RESIZE_NONE);
  manager->setLayoutInfo(cancelBut, SE_GRAV, SE_GRAV, RESIZE_NONE);
  GeoMgr *submgr1 = new GeoMgr(backFrame);
  submgr1->init();
  submgr1->setLayoutInfo(untitled_0, NE_GRAV, NE_GRAV, RESIZE_ALL);
  submgr1->setLayoutInfo(untitled_1, NE_GRAV, NE_GRAV, RESIZE_ALL);
  submgr1->setLayoutInfo(typeEdit, NW_GRAV, NE_GRAV, RESIZE_ALL);
  submgr1->setLayoutInfo(nameEdit, NW_GRAV, NE_GRAV, RESIZE_ALL);
  submgr1->setLayoutInfo(atypeGrp, NE_GRAV, NE_GRAV, RESIZE_ALL);
  GeoMgr *submgr2 = new GeoMgr(atypeGrp);
  submgr2->init();
  submgr2->setLayoutInfo(pubBox, NW_GRAV, NW_GRAV, RESIZE_ALL);
  submgr2->setLayoutInfo(protBox, NW_GRAV, NW_GRAV, RESIZE_ALL);
  submgr2->setLayoutInfo(privBox, NW_GRAV, NW_GRAV, RESIZE_ALL);
  connect(doneBut, SIGNAL(clicked()), SLOT(applyValues()) );
  connect(cancelBut, SIGNAL(clicked()), SLOT(reject()) );
}

MemberVarModal::~MemberVarModal()
{
}

void MemberVarModal::setVar(MemberVariable *mv)
{
  target = mv;
  typeEdit->setText(mv->type);
  nameEdit->setText(mv->name);
  pubBox->setChecked(0);
  protBox->setChecked(0);
  privBox->setChecked(0);
  if(mv->access == "public")
    pubBox->setChecked(1);
  else if(mv->access == "protected")
    protBox->setChecked(1);
  else //(mv->access == "private")
    privBox->setChecked(1);
}

void MemberVarModal::applyValues()
{
  // Check the validity of the fields
  if(*typeEdit->text() == '\0')
  {
    QMessageBox::critical(this, "Ebuilder", "You must enter a type");
    return;
  }
  if(*nameEdit->text() == '\0')
  {
    QMessageBox::critical(this, "Ebuilder", "You must enter a name");
    return;
  }
  target->type = typeEdit->text();
  target->name = nameEdit->text();
  if(pubBox->isChecked())
    target->access = "public";
  else if(protBox->isChecked())
    target->access = "protected";
  else //(privBox->isChecked())
    target->access = "private";
  accept();
}
