#include "pushbtpage.h"

PushButtonPage::PushButtonPage(QWidget *parent, const char *name)
: PropPage(parent, name)
{
  QFont fnt;
  QColor fg, bg, light, dark, mid, text, base;
  QColorGroup normal, disabled, active;
  QPalette pal;

  this->resize(400, 300);
  optGrp = new QGroupBox(this);
  optGrp->setGeometry(0, 0, 310, 85);
  optGrp->setTitle("Options");
  adefBox = new QCheckBox(optGrp);
  adefBox->setGeometry(5, 20, 100, 25);
  adefBox->setText("Auto Default");
  defBox = new QCheckBox(optGrp);
  defBox->setGeometry(150, 20, 100, 25);
  defBox->setText("Default");
  toggleBox = new QCheckBox(optGrp);
  toggleBox->setGeometry(5, 55, 100, 25);
  toggleBox->setText("Toggle Button");

  connect(adefBox, SIGNAL(clicked()), SLOT(setDirty()) );
  connect(defBox, SIGNAL(clicked()), SLOT(setDirty()) );
  connect(toggleBox, SIGNAL(clicked()), SLOT(setDirty()) );
}

PushButtonPage::~PushButtonPage()
{
}

void PushButtonPage::setTarget(QWidget *target)
{
  _target = (QPushButton *)target;
  adefBox->setChecked(_target->autoDefault());
  defBox->setChecked(_target->isDefault());
  toggleBox->setChecked(_target->isToggleButton());
  dirty = 0;
}

void PushButtonPage::applyValues()
{
  if(! dirty)
    return;
  _target->setAutoDefault(adefBox->isChecked());
  _target->setDefault(defBox->isChecked());
  _target->setToggleButton(toggleBox->isChecked());
  
}
