#include "radiobtpage.h"

RadioButtonPage::RadioButtonPage(QWidget *parent, const char *name)
: PropPage(parent, name)
{
  QFont fnt;
  QColor fg, bg, light, dark, mid, text, base;
  QColorGroup normal, disabled, active;
  QPalette pal;

  this->resize(400, 300);
  optGrp = new QGroupBox(this);
  optGrp->setGeometry(0, 0, 310, 55);
  optGrp->setTitle("Options");
  chkBox = new QCheckBox(optGrp);
  chkBox->setGeometry(5, 20, 100, 25);
  chkBox->setText("Checked");

  connect(chkBox, SIGNAL(clicked()), SLOT(setDirty()) );
}

RadioButtonPage::~RadioButtonPage()
{
}

void RadioButtonPage::setTarget(QWidget *target)
{
  _target = (QRadioButton *)target;
  chkBox->setChecked(_target->isChecked());
  dirty = 0;
}

void RadioButtonPage::applyValues()
{
  if(! dirty)
    return;
  _target->setChecked(chkBox->isChecked());
}
