#ifndef Shared_included
#define Shared_included

#include <qwidget.h>
#include <qlist.h>
#include <qstring.h>

typedef struct
{
  QString type;
  QString name;
  QString arglist;
  QString access;
  QString extra;
  QString text;
  QString documentation;
} MemberFunction;

typedef struct
{
  QString type;
  QString name;
  QString access;
  QString documentation;
} MemberVariable;

typedef struct
{
  QString name;
} IncludeFile;

class WidgetInfo
{
  public:
    WidgetInfo()
    {
      widget = 0;
      funcList.setAutoDelete(1);
      varList.setAutoDelete(1);
      incList.setAutoDelete(1);
      baseClass = "QWidget";
    }
    ~WidgetInfo()
    {
      if(widget)
        delete widget;
    }

    QString name;
    QString arguments;
    QString baseClass;
    QString baseInitializer;
    QString baseSubstitute;
    QString baseHeader;
    QString briefDoc;
    QString documentation;
    bool modal;

    QWidget *widget;
    QList<MemberFunction> funcList;
    QList<MemberVariable> varList;
    QList<IncludeFile> incList;
};

#endif
