#include "valmodal.h"

ValModal::ValModal(QWidget *parent, const char *name)
: QDialog(parent, name, TRUE)
{
  QFont fnt;
  QColor fg, bg, light, dark, mid, text, base;
  QColorGroup normal, disabled, active;
  QPalette pal;

  this->resize(190, 105);
  valLabel = new QLabel(this);
  valLabel->setGeometry(10, 10, 170, 25);
  valLabel->setText("This is the question");
  valEdit = new QLineEdit(this);
  valEdit->setGeometry(10, 35, 170, 25);
  okBut = new QPushButton(this);
  okBut->setGeometry(10, 70, 80, 25);
  okBut->setText("Ok");
  okBut->setDefault((bool)1);
  cancelBut = new QPushButton(this);
  cancelBut->setGeometry(100, 70, 80, 25);
  cancelBut->setText("Cancel");

  GeoMgr *manager = new GeoMgr(this);
  manager->init();
  manager->setLayoutInfo(okBut, NO_GRAV, NO_GRAV, RESIZE_NONE);
  manager->setLayoutInfo(cancelBut, NO_GRAV, NO_GRAV, RESIZE_NONE);
  connect(valEdit, SIGNAL(returnPressed()), SLOT(accept()) );
  connect(okBut, SIGNAL(clicked()), SLOT(accept()) );
  connect(cancelBut, SIGNAL(clicked()), SLOT(reject()) );
}

ValModal::~ValModal()
{
}

void ValModal::setQuestion(const char *txt)
{
  valLabel->setText(txt);
  QFontMetrics fm(QFont::defaultFont());
  valLabel->resize(fm.width(txt) + 5, valLabel->height());
  if(valLabel->width() > valEdit->width())
  {
    resize(valLabel->width() + 20, height());
    valEdit->resize(valLabel->width(), valEdit->height());
  }
  else
  {
    resize(valEdit->width() + 20, height());
    valLabel->resize(valEdit->width(), valLabel->height());
  }
}

void ValModal::setText(const char *txt)
{
  valEdit->setText(txt);
  QFontMetrics fm(QFont::defaultFont());
  valEdit->resize(fm.width(txt) + 5, valEdit->height());
  if(valLabel->width() > valEdit->width())
  {
    resize(valLabel->width() + 20, height());
    valEdit->resize(valLabel->width(), valEdit->height());
  }
  else
  {
    resize(valEdit->width() + 20, height());
    valLabel->resize(valEdit->width(), valLabel->height());
  }
  valEdit->selectAll();
  valEdit->setFocus();
}

const char * ValModal::text()
{
  return valEdit->text();
}

void ValModal::clear()
{
  valEdit->setText("");
}

void ValModal::showAtCursor()
{
  move(QCursor::pos() - QPoint(width(), height())/2 );
  valEdit->setFocus();
  show();
}
